#ifndef _GRAPH_ALG_H_
#define _GRAPH_ALG_H_

/*
 * $Log: graph-alg.h,v $
 * Revision 1.2  2001/08/08 13:24:07  suman
 * removed the rcsid string
 *
 * Revision 1.1  2001/08/07 22:06:46  suman
 * Initial revision
 *
 */

/*
 * File: graph-alg.h
 * Author: Suman Banerjee <suman@cs.umd.edu>
 * Date: July 31, 2001
 * Terms: GPL
 *
 * myns simulator
 */


#define LARGE_DOUBLE 1000000000.0

int read_graph (char *filename, double **W);
void floyd_warshall_all_pair (int count, double *W, double *D, int *NH);
void display_all_pair_paths (int count, double *D, int *NH);

#endif _GRAPH_ALG_H
