static char rcsid [] = "$Id: randomize.cc,v 1.1 2001/08/07 22:10:07 suman Exp suman $";

/*
 * $Log: randomize.cc,v $
 * Revision 1.1  2001/08/07 22:10:07  suman
 * Initial revision
 *
 */

/*
 * File: randomize.cc
 * Author: Suman Banerjee <suman@cs.umd.edu>
 * Date: July 31, 2001
 * Terms: GPL
 *
 * myns simulator
 */


#include <stdlib.h>
#include <randomize.h>

#define STATE_SIZE	256

char generic_rand_state[STATE_SIZE];

void init_generic_random (unsigned int seed) {

  initstate(seed,generic_rand_state,STATE_SIZE);
  return;
}

long int get_generic_random (void) {

  char * old_state = setstate(generic_rand_state);
  return random();
}

