/**************************************************
 *
  File: rp-agent.h
  Author: Suman Banerjee <suman@cs.umd.edu>
  Date: 15th March, 2001
  Terms: GPL

  Narada implementation in myns

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
**************************************************/

#ifndef _RP_AGENT_H_
#define _RP_AGENT_H_

#include <linked-list.h>
#include <agent.h>
#include "app-packet.h"

class rpAgent : public Agent {

public :

  int rp_id; // Id of the rendezvous point
  int rp_node_id;
 
  LinkedList<AgentInfo *, int> mc_agent_list;

  void start (void);
  void init (int Id, int Index, Node *N);

  void specific_rx_pkt_handler (Packet *p);  

  void handle_rp_ping (AppPacket *p);
};
#endif _RP_AGENT_H_
  
