
BEGIN{
	interval;
	if ( interval == "" )
		interval = 2.0;
	if (num_node == "" )
		num_node = 512;

	printf("# num_node = %d\n", num_node);

	too_large = 50;
}
{ }
END{
	now = 490;
	srand(12345);

	printf("#interval = %f\n", interval);
	printf("#start of node failures\n\n");

	num = 0;
	sum = 0;

	for ( i = 1; i <= num_node; i++ )
		up[i] = true;

	while ( now < 810 ) {
		target_time = -interval * log( 1- rand() );
		sum += target_time;
		if ( target_time > too_large )
			target_time = too_large;

		target = int (rand() * num_node * 2 + 1);
		if ( target in up ) {
			printf("at %f agent %d stop;\n", now, target );
			delete up[target];
		}
		else {
			printf("at %f agent %d start;\n", now, target );
			up[target] = true;
		}
			
		now += target_time;
		num++;
	}

	printf("#num = %d avg = %f\n", num, sum/num );
	#printf("%f\n", log(2.7) );
}
		


	
