#ifndef lint
static char yysccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93";
#endif
#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define yyclearin (yychar=(-1))
#define yyerrok (yyerrflag=0)
#define YYRECOVERING (yyerrflag!=0)
#define YYPREFIX "yy"
#line 11 "parser.y"
#include <stdio.h>
#include "main.h"
#include "parser-event.h"
#include <agent.h>
#include <constants.h>
#include <stdlib.h>

extern RoutingType global_routing_type;
extern char global_ts_routing_sgb_filename[];

extern int yylineno;
extern int yylex(void);
int yyparse (void);

extern ParserReturnInfo parser_events;

#line 29 "parser.y"
typedef union {
  double dval;
  int ival;
  char strval[MAX_NAME_SIZE];
  struct AtEvent *ae;
  AgentType atp;
  SourceDistributionType sdt;
} YYSTYPE;
#line 38 "y.tab.c"
#define TOK_SEMICOLON 257
#define TOK_NODE 258
#define TOK_EDGE 259
#define TOK_AT 260
#define TOK_START 261
#define TOK_STOP 262
#define TOK_PRINT 263
#define TOK_FINISH 264
#define TOK_COMMENT 265
#define TOK_SIMULATOR 266
#define TOK_NODECOUNT 267
#define TOK_JUNK 268
#define TOK_ATTACH 269
#define TOK_AGENT 270
#define TOK_NUMBER_INT 271
#define TOK_NUMBER_FLOAT 272
#define TOK_NAME 273
#define TOK_FILENAME 274
#define TOK_RP 275
#define TOK_MC 276
#define TOK_COOP 277
#define TOK_BSE 278
#define TOK_BEACON 279
#define TOK_QUERY 280
#define TOK_SET 281
#define TOK_BURSTSIZE 282
#define TOK_GAP 283
#define TOK_SOURCE 284
#define TOK_CONSTANT 285
#define TOK_UNIFORM 286
#define TOK_EXPONENTIAL 287
#define TOK_ROUTING 288
#define TOK_ORACLE 289
#define TOK_TS 290
#define YYERRCODE 256
short yylhs[] = {                                        -1,
    0,    0,    4,    5,    5,    5,    5,    5,    5,    6,
    6,    7,    8,    9,    2,    2,    2,    2,    2,    2,
   10,    1,    1,    1,    1,    1,    1,    1,    3,    3,
    3,   11,   11,
};
short yylen[] = {                                         2,
    2,    1,    2,    1,    1,    1,    1,    1,    1,    2,
    4,    2,    4,    6,    1,    1,    1,    1,    1,    1,
    3,    3,    3,    3,    3,    8,    2,    2,    1,    1,
    1,    3,    3,
};
short yydefred[] = {                                      0,
    0,    0,    0,    0,    0,    0,    0,    2,    0,    4,
    5,    6,    7,    8,    9,    0,    0,   12,    0,    0,
    0,    1,    3,    0,    0,    0,    0,   21,    0,   32,
   33,    0,   13,    0,   27,   28,    0,    0,   11,   22,
   24,   23,   25,    0,    0,   29,   30,   31,    0,   15,
   16,   19,   17,   20,   18,   14,    0,    0,    0,   26,
};
short yydgoto[] = {                                       7,
   28,   56,   49,    8,    9,   10,   11,   12,   13,   14,
   15,
};
short yysindex[] = {                                   -259,
 -269, -263, -250, -247, -249, -264, -259,    0, -237,    0,
    0,    0,    0,    0,    0, -244, -253,    0, -235, -265,
 -262,    0,    0, -234, -232, -251, -231,    0, -221,    0,
    0, -233,    0, -243,    0,    0, -258, -229,    0,    0,
    0,    0,    0, -271, -245,    0,    0,    0, -239,    0,
    0,    0,    0,    0,    0,    0, -227, -238, -226,    0,
};
short yyrindex[] = {                                      0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 -210,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
};
short yygindex[] = {                                      0,
    0,    0,    0,   41,    0,    0,    0,    0,    0,    0,
    0,
};
#define YYTABLESIZE 48
short yytable[] = {                                       1,
    2,   16,   42,   43,   25,   30,   31,    3,   17,    4,
   35,   36,   26,   46,   47,   48,   27,   40,   41,   23,
   18,    5,   19,   20,   21,   44,   24,   32,    6,   50,
   51,   52,   53,   54,   55,   29,   38,   33,   34,   37,
   39,   45,   57,   58,   59,   60,   10,   22,
};
short yycheck[] = {                                     259,
  260,  271,  261,  262,  258,  271,  272,  267,  272,  269,
  262,  263,  266,  285,  286,  287,  270,  261,  262,  257,
  271,  281,  270,  273,  289,  284,  271,  290,  288,  275,
  276,  277,  278,  279,  280,  271,  258,  272,  271,  271,
  274,  271,  282,  271,  283,  272,  257,    7,
};
#define YYFINAL 7
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 290
#if YYDEBUG
char *yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"TOK_SEMICOLON","TOK_NODE",
"TOK_EDGE","TOK_AT","TOK_START","TOK_STOP","TOK_PRINT","TOK_FINISH",
"TOK_COMMENT","TOK_SIMULATOR","TOK_NODECOUNT","TOK_JUNK","TOK_ATTACH",
"TOK_AGENT","TOK_NUMBER_INT","TOK_NUMBER_FLOAT","TOK_NAME","TOK_FILENAME",
"TOK_RP","TOK_MC","TOK_COOP","TOK_BSE","TOK_BEACON","TOK_QUERY","TOK_SET",
"TOK_BURSTSIZE","TOK_GAP","TOK_SOURCE","TOK_CONSTANT","TOK_UNIFORM",
"TOK_EXPONENTIAL","TOK_ROUTING","TOK_ORACLE","TOK_TS",
};
char *yyrule[] = {
"$accept : program",
"program : program statement",
"program : statement",
"statement : valid_statement TOK_SEMICOLON",
"valid_statement : route_statement",
"valid_statement : nodecount_statement",
"valid_statement : edge_statement",
"valid_statement : attach_statement",
"valid_statement : at_statement",
"valid_statement : set_statement",
"route_statement : TOK_ROUTING TOK_ORACLE",
"route_statement : TOK_ROUTING TOK_ORACLE TOK_TS TOK_FILENAME",
"nodecount_statement : TOK_NODECOUNT TOK_NUMBER_INT",
"edge_statement : TOK_EDGE TOK_NUMBER_INT TOK_NUMBER_INT TOK_NUMBER_FLOAT",
"attach_statement : TOK_ATTACH TOK_AGENT TOK_NUMBER_INT TOK_NODE TOK_NUMBER_INT agent_type",
"agent_type : TOK_RP",
"agent_type : TOK_MC",
"agent_type : TOK_BSE",
"agent_type : TOK_QUERY",
"agent_type : TOK_COOP",
"agent_type : TOK_BEACON",
"at_statement : TOK_AT TOK_NUMBER_FLOAT at_event",
"at_event : TOK_NODE TOK_NUMBER_INT TOK_START",
"at_event : TOK_AGENT TOK_NUMBER_INT TOK_START",
"at_event : TOK_NODE TOK_NUMBER_INT TOK_STOP",
"at_event : TOK_AGENT TOK_NUMBER_INT TOK_STOP",
"at_event : TOK_AGENT TOK_NUMBER_INT TOK_SOURCE source_dist TOK_BURSTSIZE TOK_NUMBER_INT TOK_GAP TOK_NUMBER_FLOAT",
"at_event : TOK_SIMULATOR TOK_STOP",
"at_event : TOK_SIMULATOR TOK_PRINT",
"source_dist : TOK_CONSTANT",
"source_dist : TOK_UNIFORM",
"source_dist : TOK_EXPONENTIAL",
"set_statement : TOK_SET TOK_NAME TOK_NUMBER_INT",
"set_statement : TOK_SET TOK_NAME TOK_NUMBER_FLOAT",
};
#endif
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 500
#define YYMAXDEPTH 500
#endif
#endif
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short yyss[YYSTACKSIZE];
YYSTYPE yyvs[YYSTACKSIZE];
#define yystacksize YYSTACKSIZE
#line 254 "parser.y"

int yyerror (char *s)
{
 printf ("[Err] in parsing line %d\n", yylineno);
 exit(-1);
 return 0;
}
#line 221 "y.tab.c"
#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab
int
yyparse()
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register char *yys;
    extern char *getenv();

    if (yys = getenv("YYDEBUG"))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if (yyn = yydefred[yystate]) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yyss + yystacksize - 1)
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#ifdef lint
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#ifdef lint
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yyss + yystacksize - 1)
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 10:
#line 84 "parser.y"
{
  global_routing_type = ROUTE_ORACLE;
}
break;
case 11:
#line 89 "parser.y"
{
  global_routing_type = ROUTE_ORACLE_TS;
  strcpy(global_ts_routing_sgb_filename,yyvsp[0].strval);
}
break;
case 12:
#line 97 "parser.y"
{
  parser_events.num_nodes = yyvsp[0].ival;
}
break;
case 13:
#line 104 "parser.y"
{
  Edge *e = new Edge (yyvsp[-2].ival,yyvsp[-1].ival,yyvsp[0].dval);
  parser_events.edge_list->Add(e,1);
}
break;
case 14:
#line 112 "parser.y"
{
  if (parser_events.attach_list->Locate(yyvsp[-3].ival) != NULL) {
    printf ("Err] Agent %d re-attached\n", yyvsp[-3].ival);
    exit(-1);
  }
  Attachment *a = new Attachment(yyvsp[-3].ival,yyvsp[-1].ival,yyvsp[0].atp);;
  parser_events.attach_list->Add(a,yyvsp[-3].ival);
}
break;
case 15:
#line 123 "parser.y"
{
  yyval.atp = AGENT_APPLICATION_RP;
}
break;
case 16:
#line 128 "parser.y"
{
  yyval.atp = AGENT_APPLICATION_MC;
}
break;
case 17:
#line 133 "parser.y"
{
  yyval.atp = AGENT_APPLICATION_BSE;
}
break;
case 18:
#line 138 "parser.y"
{
  yyval.atp = AGENT_APPLICATION_QUERY;
}
break;
case 19:
#line 143 "parser.y"
{
  yyval.atp = AGENT_APPLICATION_COOP;
}
break;
case 20:
#line 148 "parser.y"
{
  yyval.atp = AGENT_APPLICATION_BEACON;
}
break;
case 21:
#line 155 "parser.y"
{
  AtEvent * ae = yyvsp[0].ae;
  ae->at = yyvsp[-1].dval;
  parser_events.ev_list->Add(ae,yyvsp[-1].dval);
}
break;
case 22:
#line 164 "parser.y"
{
  AtEvent *ae = new AtEvent;
  ae->t = START_NODE;
  ae->node = yyvsp[-1].ival;
  yyval.ae = ae;
}
break;
case 23:
#line 172 "parser.y"
{
  AtEvent *ae = new AtEvent;
  ae->t = START_AGENT;
  ae->agent = yyvsp[-1].ival;
  yyval.ae = ae;
}
break;
case 24:
#line 180 "parser.y"
{
  AtEvent *ae = new AtEvent;
  ae->t = STOP_NODE;
  ae->node = yyvsp[-1].ival;
  yyval.ae = ae;
}
break;
case 25:
#line 188 "parser.y"
{
  AtEvent *ae = new AtEvent;
  ae->t = STOP_AGENT;
  ae->agent = yyvsp[-1].ival;
  yyval.ae = ae;
}
break;
case 26:
#line 196 "parser.y"
{
  AtEvent *ae = new AtEvent;
  ae->t = SOURCE_AGENT;
  ae->agent = yyvsp[-6].ival;
  ae->sdt = yyvsp[-4].sdt;
  ae->source_burst = yyvsp[-2].ival;
  ae->source_gap = yyvsp[0].dval;
  yyval.ae = ae;
}
break;
case 27:
#line 207 "parser.y"
{
  AtEvent *ae = new AtEvent;
  ae->t = STOP_SIMULATION;
  yyval.ae = ae;
}
break;
case 28:
#line 214 "parser.y"
{
  AtEvent *ae = new AtEvent;
  ae->t = PRINT_SIMULATION_STATUS;
  yyval.ae = ae;
}
break;
case 29:
#line 223 "parser.y"
{
  yyval.sdt = DIST_CONSTANT;
}
break;
case 30:
#line 228 "parser.y"
{
  yyval.sdt = DIST_UNIFORM;
}
break;
case 31:
#line 233 "parser.y"
{
  yyval.sdt = DIST_EXPONENTIAL;
}
break;
case 32:
#line 240 "parser.y"
{
  NamedConstant::setval(yyvsp[-1].strval,yyvsp[0].ival);
  /* Constant<int>::setval($2,$3); */
  /* constant_setval($2,$3,0.0,true); */
}
break;
case 33:
#line 247 "parser.y"
{
  NamedConstant::setval(yyvsp[-1].strval,yyvsp[0].dval);
  /* Constant<double>::setval($2,$3); */
  /* constant_setval($2,0,$3,false); */
}
break;
#line 541 "y.tab.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yyss + yystacksize - 1)
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
