
#include <stdio.h>
#include <string.h>

const int num_agent = 1024;
const int max_seq = 12000;

float sent_time[max_seq];
float recv_time[num_agent+1][max_seq];
float latency[num_agent+1][max_seq];

float sum[num_agent+1];
int deliv[num_agent+1];

int array[12000];
int nodes[10000];
int node_count;

int alternate = 0;

int added;

//int deliv;

int main() {
	//int num_line = 4053818;
	//int num_line = 3223194;
	int num_line = 9223194;
	char buf[1024];
	char temp[10][64];
	int id, seq;
	float rt, lat;

	/*
	int fec_size= 128;
	int block_size = 128;
	*/
	/**/
	int fec_size= 16;
	int block_size = 16;
	/**/

	int unit = fec_size + block_size;

	printf("FEC(%d,%d)\n", block_size, fec_size);

	for ( int i = 0 ; i < max_seq; i++ ) {
		sent_time[i] = 500 + 1.0*i/(16*unit/block_size);
	}

	for ( int i = 0 ; i < num_line; i++ ) {
		fgets(buf, 1023, stdin);
		if ( strncmp(buf, "pkt_deliv_haha", 14) == 0 )
			break;

		if ( strncmp(buf, "pkt_deliv ", 10 ) )
			continue;

//#pkt_deliv agent "id" seq "num" at "now" latency "delay"
		sscanf(buf+10, "%s %d %s %d %s %f %s %f", 
				temp[0], &id, temp[1], &seq, temp[2], &rt, temp[3], &lat );

		if ( id > num_agent || seq >= max_seq ) {
			fprintf(stderr, "STRANGE id: %d, seq: %d\n", id, seq);
			continue;
		}

		recv_time[id][seq] = rt;

		if ( nodes[id] == 0 ) {
			nodes[id] = 1;
			node_count++;
		}

	}

	//END
	

	float ff;

	for ( int i = 1; i <= num_agent; i++ ) {
		int count = 0;
		int start = 0;
		int data_count = 0;
		int miss_count = 0;

		for ( int j = 0 ; j < max_seq; j++ ) {
			if ( j % unit == 0 ) {
				if ( count >= block_size ) 
					deliv[i] += block_size;
				else
					deliv[i] += data_count;

				count = data_count = 0;
				start = j;

				miss_count = 0;
			}

			float now;
			now = recv_time[i][j];
			if ( recv_time[i][j] > 500.0 ) {
				if ( (!alternate && j % unit < block_size ) 
						|| (alternate && j % 2 == 0 )) {

					data_count++;
					ff = recv_time[i][j] - sent_time[j];
					/*
					if ( ff < 0.0 )
						fprintf(stdout, "(%d, %d) r: %f, s: %f, ff: %f\n",
								i, j, recv_time[i][j], sent_time[j], ff);
					*/
					sum[i] += ff;
					recv_time[i][j] = -1.0;
					added++;
				}
				count++;
			}
			if ( count == block_size ) {
				for ( int k = 0 ; k < unit && start+k <= j; k++ ) {
					/*
					if ( (!alternate && (start+k) % unit >=block_size ) 
							|| (alternate &&  (start+k)% 2 == 1 )) 
						continue;
					*/

					if ( recv_time[i][start+k] < 0.0 )
						//already processed!
						continue;

					miss_count++;

					ff = now - sent_time[start+k];
					if (ff <0.0)
						fprintf(stdout, "(%d, %d) r: %f, s: %f, ff: %f\n",
								i, j, recv_time[i][j], sent_time[j], ff);

					sum[i] += ff;
					added++;

					if ( miss_count >= count - data_count )
						break;
				}
				j = start + unit -1;
			}
		}
	}

	int step = 50;
	int mili;
	int tdeliv = 0;
	for ( int i = 1 ; i <= num_agent; i++ ) {
		if ( deliv[i] <= 0 )
			continue;
		tdeliv += deliv[i];

		//printf("i: %d, deliv: %d sum: %f\n", i, deliv[i], sum[i] );

		float ftemp = (sum[i]/deliv[i] * 1000 +1);
		mili = (int) ftemp;
		if ( mili < 12000 )
			array[mili]++;
	}

	printf("#ndoe_count=%d, tdeliv = %d, added=%d\n", node_count, tdeliv, added);
	for ( int k = 0 ; k <= 1500; k++ ) {
		if ( k % step == 0 )
			printf("%d \t%f\n", k, 1.0*array[k]/node_count );
		array[k+1] += array[k];
	}
			


	/*
	printf("1000000 ");
	for ( int k = 0 ;  k < block_size; k++ )
		printf("0.1 ");
	printf("0.1\n");
	*/

			
	//printf("%f\n", recv_time[0][0]);
	return 0;
}
