/**************************************************
 *
  File: uninode.h
  Author: Suman Banerjee <suman@cs.umd.edu>
  Date: July 31, 2001
  Terms: GPL

  UNI implementation in myns

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 **************************************************/

#ifndef _UNINODE_H_
#define _UNINODE_H_

#include <node.h>

class UniNode : public Node {

public:

  int m_data_packet_count;
  int m_control_packet_count;

  int * m_per_node_data_pkt_count;

public:

  UniNode(void);
  ~UniNode(void);

  void specific_tx_pkt (Packet *p, int dst);
  void specific_rx_pkt_handler (Packet *p, bool is_src);

  void display_on_stop_simulation (void);
};

#endif _UNINODE_H_
