
BEGIN{
	block_size;
	fec_size
	if ( block_size == "" )
		block_size = 20;
	if ( fec_size == "" )
		fec_size = 20;
	
	if ( num_agent == "" )
		num_agent =1024;
	
	cache;
	unit = block_size + fec_size;
	deliv = 0;
	tup = 2560000;
	recv = 1931968;
	cut_off = 16000;
	printf("FEC(%d,%d)\n",block_size, fec_size);
}
{ 
#pkt_deliv agent "id" seq "num" at "now" latency "delay"
	if ( $1 == "pkt_deliv" ) {
		seq = $5;
		id = $3;

		cache[id, seq] = true;
	}
	else if ( $1 == "pkt_deliv_haha" ) {
		recv = $3;
		tup = $4;
	}
}
END{
	for ( i = 1; i <= num_agent; i++ ) {
		count = 0;
		data_count = 0;
		for ( j = 0 ; j <= cut_off; j++ ) {
			if ( j % unit == 0 ) {
				if ( count >= block_size )
					deliv += block_size;
				else
					deliv += data_count;
				#if ( i == 456 ) print count;
				count = 0;
				data_count = 0;
			}
			if ( (i, j) in cache ) {
				count++;
				total_count++;
				if ( j % unit < block_size )
					data_count++;
			}
		}
	}
			
	#print total_count;
	perfect = int(tup *block_size/unit);
	printf("deliv %d possible %d recv %d\n", deliv, perfect, recv);
	printf("%f %f\n\n", 1.0*deliv/perfect, 1.0*recv/deliv);
}
		


	
