
BEGIN{
	fraction;
	if ( fraction == "" )
		fraction = 0.3 ;
	if (num_node == "" )
		num_node = 512;

	if ( rseed == "" )
		rseed = 12345;

	if ( total_num == "" )
		total_num = 10176

	num_change = int(num_node *fraction+0.5);
	printf("# num_node = %d\n", num_node);
	printf("# up = down = %d\n", num_change );
	duration = 300;
	start_time = 500;

	up_num = down_num = num_change;
}
{ }
END{
	now = 490;
	srand(rseed);

	for ( i = 0 ; i < down_num ; i++ )
		temp = rand();

	printf("#start of node failures\n\n");

	num = 0;
	sum = 0;

	for ( i = 0 ; i < down_num; i++ ) {
		target = int ( rand() * num_node + 1 );
		while ( target in already_down )
			target = int ( rand() * num_node + 1 );

		already_down[target] = true;
		down_time[target] = rand() * duration + start_time;
		printf("at %f agent %d stop;\n", down_time[target], target );
	}


	if ( 2*num_node < total_num ) {
		for ( i = 0 ; i < up_num; i++ ) {
			target = int ( rand() * num_node + 1 ) + num_node;
			while (	target in already_up )
				target = int ( rand() * num_node + 1 ) + num_node;

			already_up[target] = true;
			up_time = rand() * duration + start_time;
			printf("at %f agent %d start;\n", up_time, target );
		}
	}
	else if (1) {
		for ( i = num_node + 1; i < total_num; i ++ ) {
			target = i;
			up_time[target] = rand() * duration + start_time;
			printf("at %f agent %d start;\n", up_time[target], target );
		}
	}
	else {
		if ( up_num < total_num - num_node ) {
			for ( i = 0 ; i < up_num; i++ ) {
				target = int ( rand() * total_num );
				while (	target in already_up || target <= num_node )
					target = int ( rand() * total_num );

				already_up[target] = true;
				up_time[target] = rand() * duration + start_time;
				printf("at %f agent %d start;\n", up_time[target], target );
			}
		}
		else {
			for ( i = 0 ; i < up_num; i++ ) {
				ut = rand() * duration + start_time;
				target = int ( rand() * total_num  );
				while (	target in already_up || 
						( target <= num_node && (already_down[target] != true || down_time[target] > ut )) ) {
					target = int ( rand() * total_num  );
				}

				already_up[target] = true;
				up_time[target] = ut;
				printf("at %f agent %d start;\n", up_time[target], target );
			}
		}
	}
}
		
