
BEGIN{
	node_count;
	array;
	unit = 5;
	numnode = 1024;
}
{ 
#node-info id deliv recv latency up-time
	deliv = $3;
	latency = $5;
	up_time = $6;
	possible = int(up_time*16);

	if ( possible > 0 ) {
		node_count++;

		loss = 100/unit - int ( 100.0 * deliv / possible / unit );
		if (loss < 0 ) {
			print deliv "\t" possible;
			loss = 0;
		}
		if ( loss in array ) 
			array[loss]++;
		else
			array[loss] = 1;
	}

}
END{
	printf("node_count = %d\n", node_count);

	#for ( i = 0 ; i < 100; i++ ) {
		#if (  array[i] > 0 )
			#printf("%d %f\n", i * unit, 1.0*array[i]/node_count );
	#}

	for ( i = 0 ; i <= 20; i++ ) {
		array[i] += array[i-1];
			printf("%d %f\n", i * unit, 1.0*array[i]/node_count );
	}

	#print array[20];


}
		


	
