
BEGIN{
	node_count;
	array;
	step = 50;
	numnode = 1024;
}
{ 
#node-info id deliv recv latency
	if ( $1 == "node-info" ) {
		deliv = $3;
		latency = $5;
		if ( deliv > 0 ) {
			node_count++;
			latency = latency/deliv;

			mili = int ( latency * 1000 +1);
			array[mili]++;
		}
	}

}
END{
	printf("node_count = %d\n", node_count);

	#for ( i = 0 ; i < 100; i++ ) {
		#if (  array[i] > 0 )
			#printf("%d %f\n", i * step, 1.0*array[i]/node_count );
	#}

	for ( i = 0 ; i <= 1500; i++ ) {
		array[i] += array[i-1];
			if ( i % step == 0 ) printf("%d \t%f\n", i , 1.0*array[i]/node_count );
	}

}
		


	
