
BEGIN {
	dstart = 500;
	dend = 825;
	sim_end = 851;
	if ( drate == "" )
		drate = 16;
}
{
	if ( $6=="up") {
		uptime[$2] = $7;

		if ( $7 < dstart )
			dtime[$2] = dstart;
		else 
			dtime[$2] = $7;
	}
	else if ( $6 =="down") {
		total_time += $7 - uptime[$2];
		uptime[$2] = 0;

		temp = $7;
		if ( temp > dend )
			temp = dend;
		if ( temp > dtime[$2] )
			data_up += temp - dtime[$2];

		dtime[$2] = 0;
	}
}
END {
	for ( i = 0 ; i < 11000; i++ ) {
		if ( uptime[i] > 0 ) {
			total_time = total_time + sim_end -uptime[i];
			cnt++;
		}

		if ( dtime[i] > 0 ) {
			if ( dtime[i] < dend ) 
				data_up += dend -dtime[i];
		}
	}

	print total_time "  " cnt "  " data_up * drate /1000 "  " data_up /cnt;
}
