
#include <stdio.h>
#include <string.h>

const int num_agent = 1024;
const int max_seq = 5000;

int recv[num_agent+1][max_seq];
int cdf[max_seq];
int holes[max_seq];

int nodes[10000];
int node_count;

int alternate = 0;

int added;

//int deliv;

int change[num_agent+1];
int more_count;
int more_than_two[num_agent+1];

int main() {
	//int num_line = 4053818;
	//int num_line = 3223194;
	int num_line = 9223194;
	char buf[1024];
	char temp[10][64];
	int id, seq;
	float rt, lat;
	int total_count = 0;

	for ( int i = 0 ; i < num_line; i++ ) {
		fgets(buf, 1023, stdin);

		if ( strncmp(buf, "pkt_deliv_haha", 14) == 0 )
			break;

		if ( strncmp(buf, "pkt_deliv ", 10 ) != 0 && strncmp( buf, "at ", 3) != 0 )
			continue;

		if ( strncmp( buf, "at ", 3) == 0 ) {
			sscanf( buf+4, "%f %s %d %s", &lat, temp[0], &id, temp[1] );
			//printf("%d\n", id);
			if ( change[id] ) {
				//fprintf(stdout, "%d\n", id);
				more_than_two[id] = 1;
			}
			change[id]++;
			continue;
		}

//#pkt_deliv agent "id" seq "num" at "now" latency "delay"
		sscanf(buf+10, "%s %d %s %d %s %f %s %f", 
				temp[0], &id, temp[1], &seq, temp[2], &rt, temp[3], &lat );

		if ( id > num_agent || seq >= max_seq ) {
			fprintf(stderr, "STRANGE id: %d, seq: %d\n", id, seq);
			continue;
		}

		recv[id][seq] = 1;
		total_count++;

		if ( nodes[id] == 0 ) {
			nodes[id] = 1;
			node_count++;
		}

	}

	//END
	

	int gap = 0;
	int holes_count = 0;
	int got_first = 0;
	for ( int i = 1; i <= num_agent; gap = 0, got_first = 0,i++ ) {
		//printf("mg= %d, gap= %d\n", holes[i], gap);

		for ( int j = 0 ; j < max_seq; j++ ) {
			if ( recv[i][j] == 0 )
				gap++;
			else
				if ( gap > 0 ) {
					holes[gap]++;
					gap = 0;
					holes_count++;
				}
		}

	}

	int step = 1;

	printf("#ndoe_count=%d, tc= %d, more_count = %d\n", node_count, holes_count, more_count);
	for ( int k = 0 ; k < 100; k++ ) { //max_seq-1 ; k++ ) {
		if ( k % step == 0 ) {
			printf("%d \t%f\n", k, 1.0*holes[k]/holes_count );
			if ( holes[k] == holes_count )
				break;
		}
		holes[k+1] += holes[k];
	}
			

	//printf("%f\n", recv_time[0][0]);
	return 0;
}
