/*
 * File: routing.h
 * Author: Suman Banerjee <suman@cs.umd.edu>
 * Date: July 31, 2001
 * Terms: GPL
 *
 * myns simulator
 */


#ifndef _TSROUTING_H_
#define _TSROUTING_H_

#include "gb_graph.h"

//#define RT_SUFFIX ".rt"
int print_route (int a, int b);
int iter_print_route (int a, int b);
int next_hop (int a, int b);
int rt_num_hops (int s, int d);
//void print_connectivity_matrix (int n, long **dist);
long create_routing_table(Graph *g);
int allocate_route_table(Graph *g);
//boolean save_route_table (char *f, Graph *g, long **t);
//boolean get_route_table(Graph *G, char *RT_FILE_NAME, char *GR_FILE_NAME);

#endif _TSROUTING_H_ 
